import numpy as np
import matplotlib.pyplot as plt

def f(x):
	return x**3

def df(x):
	return 3*x**2

def approx_df(x0,x1):
	return (f(x1)-f(x0))/(x1-x0)

dx = 0.1
xmin = -2
xmax = 2 + dx
x = np.arange(xmin,xmax,dx)
x1 = x+dx*2
x2 = x+dx*4
plt.plot(x,f(x),'k-', label="$f(x)=x^3$")
plt.plot(x,df(x),'b-', label="$f'(x)=3\cdot x^2$")
plt.plot(x,approx_df(x,x1),'rx', label="$h=0.2$") # approx 0.2
plt.plot(x,approx_df(x,x2),'gx', label="$h=0.4$") # approx 0.4
plt.legend(loc=4)

plt.grid(True)
plt.show() # show on screen