import numpy as np
import matplotlib.pyplot as plt

def f(x): 
	return x**3

def df(x): 
	return 3 * x**2

x0 = 0.0
dx = np.arange(0.05,0.5,0.05)
x = np.array([])
deriv = np.array([])
e = np.array([])
for delta in dx:
	x = np.append(x, x0 + delta)
	dd = (f(x0 + delta)-f(x0))/delta
	deriv = np.append(deriv, dd)
	e = np.append(e, abs(df(x0) - dd))

max_d2 = np.max(e/dx)

plt.figure(1)

plt.subplot(121)
plt.title('Fonction')
plt.plot(x, f(x), 'b-', label="$x^3$")
plt.plot(x, df(x), 'kx-', label="$3\cdot x^2$")
plt.plot(x, deriv, 'rx-',  label="$fin. diff. avant$")
plt.xlabel('$x$')
plt.legend(loc=0)
plt.grid(True)

plt.subplot(122)
plt.title('Erreur')
plt.plot(dx, e,   'kx-', label="$E(x)$")
plt.plot(dx, dx * max_d2,  'r-', label="$\max_y\{ f''(y)\} \cdot x$")
plt.xlabel('$h$')

plt.legend(loc=0)
plt.grid(True)
plt.show()
# plt.savefig('deriv_avant_1.svg')
