import numpy as np
import matplotlib.pyplot as plt
import math

def f(x):
	return x**3

def df(x):
	return 3*x**2

dx = 0.2
xmin = 0
xmax = math.pi-dx
x = np.arange(xmin,xmax,dx)
x12 = x + dx/2
x1 = x + dx
x_1 = x - dx

plt.plot(x, f(x), 'k-', label="$f(x)=x^3$")
plt.plot(x, df(x),'b-', label="$f'(x)=2\cdot x^2$")
plt.plot(x,(f(x1)-f(x)) / dx,  'rx', label="$f'(x), avant$")
plt.plot(x,(f(x)-f(x_1)) / dx, 'go', label="$f'(x), arriere$")
plt.plot(x12,(f(x1)-f(x)) / dx,'cs', label="$f'(x), centrale$")

plt.legend(loc=2)

plt.grid(True)
plt.savefig("finite_diff.svg")
plt.show()