import numpy as np
import matplotlib.pyplot as plt
import math

def g(x):
	return 1/(1+x**2)

def echant(x0, x1, n, f):
	dx = (x1-x0)/n
	x = np.arange(x0,x1+dx/10,dx)
	# return (x,np.sin(x))
	return (x,f(x))

def delta(x, y):
	if len(x) == 1:
		return y[0]
	else:
		return (delta(x[1:],y[1:]) - delta(x[0:len(x)-1], y[0:len(y)-1])) / (x[len(x)-1] - x[0])

def prod(x0, x):
	if len(x) == 1:
		return x0-x[0]
	else:
		return (x0-x[len(x)-1]) * prod(x0, x[0:len(x)-1])

def newt(deltas, x0, x):
	tot = deltas[0]
	for i in range(1,len(x)):
		tot += deltas[i] * prod(x0, x[0:i])
	return tot

def delta_proc(x, y, d):
	delta = np.array([])
	for i in range(0,len(x)-1-d):
		delta = np.append(delta, (y[i+1] - y[i]) / (x[i+1+d] - x[i]))

	return delta

def get_deltas(x, y):
	test = y
	deltas_proc = np.array([y[0]])
	for d in range(0,len(x)-1):
		test = delta_proc(x, test, d)
		deltas_proc = np.append(deltas_proc, test[0])

	return deltas_proc

n = 100
x0 = -5
x1 = 5
(x,y) = echant(x0, x1, n, np.sin)

# deltas = np.array([])
# for i in range(0,len(x)):
# 	deltas = np.append(deltas, delta(x[0:i+1],y[0:i+1]))

deltas_proc = get_deltas(x,y)

# test_y = np.array([])
# for i in x:
# 	test_y = np.append(test_y, newt(deltas, i, x))

# print(np.sum((y-test_y)**2))
# print(np.sum((deltas-deltas_proc)**2))

plt.plot(x,y,'ko')

n *= 100
dx = (x1-x0) / n
xx = np.arange(x0, x1+dx/10, dx)
yy = np.array([])
for i in xx:
	yy = np.append(yy, newt(deltas_proc, i, x))

axes = plt.gca()
axes.set_ylim([-1.1,1.1])

plt.plot(xx,yy,'r-')
(x,y) = echant(x0, x1, n, np.sin)
plt.plot(x,y,'k-')
plt.xlabel("$x$")
plt.title("$n=100$")
plt.ylabel("$\sin(x)$")
plt.grid(True)
# plt.show()
plt.savefig('sin_100.svg')

