import numpy as np
import matplotlib.pyplot as plt
import math

def f(x): # sinus + bruit
	return np.sin(x) + np.random.rand(len(x))*0.1

def approx_df(x,dx): # diff finies en avant
	tmp = f(x)
	return (np.roll(tmp,-1)-tmp) / dx

dx = 0.2
xmin = -math.pi
xmax = math.pi-dx
x = np.arange(xmin,xmax,dx) # intervalle
np.random.seed(0) # init noise
plt.plot(x,f(x),'k-o', label="$f(x)$")

np.random.seed(0) # init niose
plt.plot(x,approx_df(x,dx),'r-o', label="$f'(x), approx$")
plt.legend(loc=2)

plt.grid(True)
plt.show() # afficahge à l'écran