import numpy as np
import matplotlib.pyplot as plt
import math

def f(x): 
	return np.exp(x)

def p(x):
	return 1+x

def df(x): 
	return np.exp(x)

x0 = 0
dx = np.arange(0,0.3,0.05)
x = np.array([])
e = np.array([])
for delta in dx:
	x = np.append(x, x0 + delta)
	e = np.append(e, f(x0 + delta)-p(x0 + delta))

plt.figure(1)

plt.subplot(121)
plt.title('Exponentielle')
plt.plot(x, f(x), 'kx-', label="$e^x$")
plt.plot(x, p(x), 'rx-',  label="$1+x$")
plt.xlabel('$x$')
plt.legend(loc=0)
plt.grid(True)

plt.subplot(122)
plt.title('Erreur')
plt.plot(x**2, e,   'kx-', label="$E(x)$")
plt.plot(np.arange(0,0.3**2,0.05), 0.525*np.arange(0,0.3**2,0.05), 'r-',  label="$0.525\cdot x$")
plt.xlabel('$x^2$')
plt.legend(loc=0)
plt.grid(True)
# plt.show()
plt.savefig('taylor_exp.svg')
