---
# author:
# - Orestis Malaspinas
title: Travail pratique sur les interpolations
autoSectionLabels: true
autoEqnLabels: false
eqnPrefix: 
  - "éq."
  - "éqs."
chapters: false
numberSections: false
chaptersDepth: 1
sectionsDepth: 3
lang: fr
documentclass: article
papersize: A4
cref: false
pandoc-numbering:
  - category: exercice
urlcolor: blue
---
\newcommand{\real}{\mathbb{R}}
\newcommand{\vectwo}[2]{\begin{pmatrix}#1 \\ #2 \end{pmatrix}}
\newcommand{\vecthree}[3]{\begin{pmatrix}#1 \\ #2 \\ #3 \end{pmatrix}}
\newcommand{\mat}[1]{\underline{\underline{#1}}}
\newcommand{\mattwo}[4]{\begin{pmatrix}
								#1 & #2 \\
								#3 & #4
						\end{pmatrix}}

# But du travail et rendu

Le but de ce travail pratique est de comprendre les différents types d'interpolations en une et deux dimensions.

Vous devez utiliser un langage orienté objet et mettez en pratique les idées que vous avez vu au cours de POO.

Vous devez rendre un rapport avec la structure suivante:

1. Introduction (Pourquoi fait-on ce travail? Que contient-il?).
2. Rappel théorique (Quelles sont les méthodes que vous utilisez? Quels sont leurs propriétés/avantages/inconvénients de chacune?).
3. Applications (Quelles mises en pratique faites-vous? Dans quel but? Que constatez-vous pour chaque application que vous avez faite?).
4. Conclusion (Résumé de votre travail et des applications. Quelles sont les observations les plus importantes que vous avez faites? Quelles perspectives d'avenir voyez-vous pour votre travail?)

Le travail doit être effectué par groupe de trois (n'oubliez pas de mentionner les trois noms sur le rapport et dans le code). 
Mettre le rapport et le code dans une archive `.zip`  contenant un répertoire nommé d'après les auteur du rapport séparés avec des `_`. Exemple: Si les trois étudiants ayant écrit le code et rédigé le rapport s'appellent Albuquerque, Lazeyras, et Zaffalon, le répertoire s'appellera `albuquerque_lazeyras_zaffalon` et l'archive `albuquerque_lazeyras_zaffalon.zip`. L'archive doit être déposée sur  `Cyberlearn`.

La note sera une combinaison entre le code rendu et le rapport (moitié/moitié). 

# Interpolation unidimensionnelle

1. Choisir une fonction $f(x)$ de votre choix (une fonction transcendantale, rationnelle, ... mais évitez quelque chose de trop simple). Votre design doit être assez général pour que cela soit "simple" de changer de fonction.
2. Échantillonner la fonction entre $x=a$ et $x=b$ avec un nombre $N$ de points (on suppose que la fonction est bien définie entre $a$ et $b$).
3. Implémenter une interpolation polynomiale de degré $N-1$ à l'aide des différences divisées de Newton et mettre en évidence les problèmes d'oscillation de Runge et de précision numérique que nous avons vues en cours.
4. Implémenter une interpolation continue par morceaux de degré un.
5. Implémenter une interpolation spline scellé.
6. Calculer l'erreur de chacun des type d'interpolation. Pour ce faire il faut comparer les valeurs de $f(x)$ avec celles de votre interpolation entre pour $x\in[a,b]$ pour différents $N$.

# Interpolation bi-dimensionnelle

Implémenter une interpolation bi-dimensionnelle pour interpoler des images en niveau de gris pour chacune des méthodes ci-dessus (l'interpolation polynomiale de degré $N-1$, l'interpolation 
continue par morceau de degré un, et l'interpolation spline scellé). 

Pour ce faire il suffit de faire des interpolations uni-dimensionnelles dans chacune des directions. Illustrer vos résultats en augmentant la résolution de l'image et comparez les résultats d'abord visuellement, puis en effectuant des "différences".



